// Define various ADC prescaler
const unsigned char PS_16 = (1 << ADPS2);
const unsigned char PS_128 = (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
char Buf;   // 1 caractère
char Ligne[8];          // La ligne de stockage 8 caractères au maximum
int iCmde;    // un entier correspondant au n° de commande
float fCmde;  // une valeurs décimales négative ou positive
char valtxt1[3], valtxt2[5];
int i;
unsigned int Rapport_Cyclique;
// Pin 9 has Heater from TCT_Hardware connected for test.
// Pin 5 has a led for other test
// give it a name:
int Hfil = 9;
int Pol = 10;
int Gbias = 13;
int Va = 3;
int Dva = 11;
int iVal;
// Variable for stored data
float fPower;
float fVoltage;
float fVamax;
float fVemax;
float fVacurrent;
float fPolmax;
float fGbias;
int iMesa = 0;
int iMesht =0;
float fMesht = 0;
float fVecurrent;
int duty = 0;
int x;
int measure;
int power_level = 0;
int iMespol = 0;
// Booster 
unsigned long values[10];
unsigned long iMesureht[100];
unsigned long iMesureb[100];


void setup()
{
  // set the frequency to 31.2 Khz for the PWM on pin 9,10 & 11 with timer1
  TCCR0B = TCCR0B & 0b11111000 | 0x01;
  TCCR1B = TCCR1B & 0b11111000 | 0x01;
  TCCR4B = TCCR4B & 0b11111000 | 0x01;
  Serial.begin(115200);
  pinMode(Hfil, OUTPUT); 
  pinMode(Va, OUTPUT);
  pinMode(Dva, OUTPUT); 
  pinMode(Pol, OUTPUT);
  // set up the ADC
  ADCSRA &= ~PS_128;  // remove bits set by Arduino library
  // you can choose a prescaler 
  ADCSRA |= PS_16;    
  // set our own prescaler to 16 
  Rapport_Cyclique = 0;

}

void loop()
{
  while (Serial.available())   
  {
    Buf = Serial.read(); 
    Ligne[i] = Buf; 
    i++;

    if (Buf == '\n')   
    { 
      Ligne[i] = '\0';

      sscanf(Ligne, "%s %s", &valtxt1, &valtxt2);

      iCmde = atoi(valtxt1);
      fCmde = atof(valtxt2);

      i = 0;

      switch (iCmde) {
      case 1:
        fPower=fCmde;
        break;
      case 2:
        fVamax=fCmde;
        break;
      case 3:
        fVemax=fCmde;
        break;
      case 11:
        fGbias = fCmde;
        analogWrite(Gbias,fGbias);
        iMespol = analogRead(A3); 
        Serial.println(iMespol);
        break;   
      case 12:
        fPolmax = fCmde;  
        analogWrite(Pol,fPolmax);
        iMespol = analogRead(A3); 
        Serial.println(iMespol);          
        break; 
      case 13:
        iMesht = analogRead(A5);
        if (iMesht>54)
        {
          analogWrite(Dva,200);
          delay(300000);
          analogWrite(Dva,0);
        } 
        else {

        }  
        break;   
      case 14:
        fVamax = fCmde;  
        analogWrite(Va,fVamax);

        break; 
      case 15:
        fVacurrent=fCmde;
        measure = analogRead(A5);
        power_level = SetVoltage(fVacurrent);
        //Serial.println(measure);
        //Serial.println(power_level);

        if (measure>power_level) {

          analogWrite(Dva,200);
          delay(300000);
          analogWrite(Dva,0);
          analogWrite(Va,210);
          delay(fVacurrent*200);
          analogWrite(Va,0);

        } 
        else if (measure<power_level) {
          analogWrite(Va,200);
          delay(fVacurrent*210);
          analogWrite(Va,0);

        } 
        else {
          return;
        }

        iMesht = analogRead(A5);
        Serial.println(iMesht);
        fMesht = ((iMesht*0.3540)-18.35);
        // Convert the analog reading (which goes from 0 - 1023) to a HT voltage
        Serial.println(fMesht);
        iVal = analogRead(A0);
        // Convert the analog reading (which goes from 0 - 1023) to a B+ voltage
        fVoltage = iVal * (24.00/1023);
        Serial.println(fVoltage);
        mesure();

        break; 
      case 16:
        fVecurrent=fCmde;

        break;  
      case 18:
        Rapport_Cyclique = (fCmde/fPower)*255;
        analogWrite(Hfil,Rapport_Cyclique);     // met à jour la nouvelle valeur du rapport cyclique
        delay(500000);
        iVal = analogRead(A0);
        //Serial.println(iVal);
        // Convert the analog reading (which goes from 0 - 1023) to a voltage (0 - 5V):
        fVoltage = iVal * 0.024;
        Serial.println(fVoltage);
        // convert the value you read:
        Rapport_Cyclique = (fCmde/fVoltage)*255;
        //Serial.println(Rapport_Cyclique);
        analogWrite(Hfil,Rapport_Cyclique);     // met à jour la nouvelle valeur du rapport cyclique
        break;
      case 19:
        unsigned int i;
        double fTension[5];
        double fTensionht[5];
        // capture the values to memory
        for(i=0;i<5;i++) {
          delay(10000);  
          values[i] = analogRead(A5);
          fTensionht[i] = (values[i]*0.3540)-18.35;
          Serial.print(values[i]);
          Serial.print(" = ");
          Serial.print(fTensionht[i]);
          Serial.print("\n");
        }

        break;
      default: 
        // if nothing else matches, do the default
        // default is optional
        break;
      }


    }

  }


}
// Calculate the desired analog input reading, for a given voltage
unsigned int SetVoltage(double voltage) {
  if (voltage>fVamax) {
    return 0; // do not exceed Va max
  }

  // This function converts the voltage value (0 to 5V reading; 0 to Vamax actual), into a value for an analog input (from 0 to 1024)
  // If your resistor voltage divider is not perfectly 476.8/6.8 you'll need to change the formula below

  // with ideal resistors and a perfect 5V Analog Reference voltage (AREF), an analog input value of 2.92 would be 1V

  return ((voltage*2.92)+52);
  // ideal ADC value, per volt     = voltage*(1024/5)/(476.8/6.8) = 2.9207
  // the real value for my circuit = voltage*(204.8)/(to be calculated)  = X

  // 70.1177 was my measured resistor voltage divier ratio.
  // I increased my calculated 2.92 constant to 2.92, by trial and error, in order to get closer to the target voltage
  // My results were +/- 6V, at a 0.1mA (100Kohm) load when powered by the Arduino.

}
// This function for read the analog voltage and send the data 
String mesure () {

  Serial.println("voici la mesure demandee");
  unsigned int i;
  int j;
  double fTensionht[100];
  double fTensionb[100];
  // capture the values to memory
  for(i=0;i<100;i++) {
    iMesureht[i] = analogRead(A5);
    delay(30);
    iMesureb[i] = analogRead(A0);
    j = iMesureht[i];

    if (j>56) {
      fTensionht[i] = (iMesureht[i]*0.3540)-18.35;
      fTensionb[i] = (iMesureb[i]*0.005);
      Serial.print(fTensionht[i],4);
      Serial.print(" ");
      Serial.print(fTensionb[i],4);
      Serial.print("\n");
      delay(40000);
    } 
    else {
      break;
    }
  }

}


